#L=[5,7,8,2,9]

import time
import matplotlib.pyplot as plt
from random import randint

def nb2SacMin(l, taillesac):
    poidsTot=sum(l)
    if poidsTot%taillesac==0:
        return int(poidsTot/taillesac)
    else:
        return poidsTot//taillesac+1

def produit2Listes(l, m):
    prod=[]
    for i in l:
        for j in m:
            prod.append(i+j)
    return prod

def puissanceListe(l, n):
    """ une liste et un entier, renvoie toutes les combinaisons avec repetition de n élements de l"""
    if n == 1:
        return l
    else:
        listeAvant=puissanceListe(l,n-1)
        return(produit2Listes(l,tuple(listeAvant)))
    
def listeCombinaison(nbsac, nbObjet):
    l=[[i] for i in range(1,nbsac+1)]
    return puissanceListe(l,nbObjet)

    
def test1Combinaison(L, combi, nbsac, tailleSac):
    """test une combinaison donnée"""
    poidsSaci=[0]*nbsac
    for j in range(len(L)):
        poidsSaci[combi[j]-1]+=L[j] # ajouter les poids des objets dans chaque sac et stocke dans poidsSaci
    for sac in poidsSaci:
        if sac >tailleSac:          # test de taille
            return False 
    return True

def testAllCombinaison(L, nbSac, tailleSac):
    """ recherche un combinaison correcte pour un nombre de sac donné"""
    nbObjet= len(L)
    Combi= listeCombinaison(nbSac, nbObjet)          # creer la liste des possibles
    for l in Combi:
        if test1Combinaison(L, l, nbSac, tailleSac): # teste chaque possible
            return l, nbSac
    return None
              
def showAllCombinaison(L, nbSac, tailleSac):
    """recherche toutes les combinaisons pour un nombre de sac donné"""
    nbObjet= len(L)
    combinaison= listeCombinaison(nbSac, nbObjet)        # creer la liste des possibles
    listeBonneCombi=[]
    for combi in combinaison:
        if test1Combinaison(L, combi, nbSac, tailleSac): # teste chaque possible
            miseEnForme= affichageSac(L,combi,nbSac)     # regroupe par sac
            listeBonneCombi.append(miseEnForme)          #l'ajoute a la liste des bonnes combinaisons
    return listeBonneCombi
                       
def rechercheOptimal(L, tailleSac):
    """recherche un rangement optimal au sens du nombre de sac"""
    nbsacmin= nb2SacMin(L, tailleSac)
    nbObjet= len(L)
    
    for i in range(nbsacmin, nbObjet+1):
        result= testAllCombinaison(L, i, tailleSac)
        if result :
            return affichageSac(L,*result)             # regroupe par sac et affiche
    return 'Impossible'

def rechercheAllOptimal(L, tailleSac):
    """recherche tous les rangement possibles"""
    nbsacmin= sum(L)//tailleSac
    nbObjet= len(L)
    listeOptimalComb=[]
    i=nbsacmin                                # On commence a chercher avec un nombre de sac min puis on incremente
    while listeOptimalComb==[]:               # Quand on a des solutions pour un nombre de sac alors il est optimal et on affiche 
        listeOptimalComb= showAllCombinaison(L, i, tailleSac)
        i+=1
    return listeOptimalComb

def affichageSac(listeObj, dispoSac, nbSac):
    """ affiche les objets sac par sac"""
    nbObjet=len(listeObj)
    return([[listeObj[i] for i in range(nbObjet) if dispoSac[i]==j] for j in range(1,nbSac+1)])

def complexite(depart, fin, masse_max ):
    for i in range(depart, fin+1):
        l=[randint(1, 10) for j in  range(i)]
        
        tempsInit=time.clock()
        rechercheOptimal(l,masse_max)
        tempsFin=time.clock()
        plt.plot(i,tempsFin-tempsInit,'bo')
            
        tempsInit=time.clock()
        firstFit(l,masse_max)
        tempsFin=time.clock()
        plt.plot(i,tempsFin-tempsInit,'r*')
        
    plt.xlabel("Nombre d'objets")
    plt.ylabel("Temps en s") 
    plt.show()
    
def tempsMoyen(taille, nbObjet):
    """temps moyen pour un echantillon de taille avec nb elements"""
    temps=0
    for j in range(taille):
        l=[randint(0, 10) for i in  range(nbObjet)]
        tempsInit=time.clock()
        rechercheOptimal(l,10)
        tempsFin=time.clock()
        temps+=tempsFin-tempsInit
    return temps/taille
        

def remplir_sac (t,t2,masse_max) :
    masse= 0
    i=0
    while  masse < masse_max and i<=len(t)-1:
        if masse + t[i] <= masse_max :
            masse += t[i]
            t2.append(t[i])
            t.pop(i)
        else :
            i += 1

    return (t,t2)

def firstFit(t, masse_max):
    """algo firstFit"""
    t.sort(reverse=True)
    t2=[]
    s=0
    while len(t)!= 0 :
        t,t2 = remplir_sac (t,t2,masse_max)
        s += 1
    return s, t2


def glouRetour(l,masse_max):
    sac=[[]]
    masses=l[:]
    for i in range(len(masses)):
        indice_sac=0
        indice=randint(0,len(masses)-1)
        while sum(sac[indice_sac])+masses[indice]>masse_max:
            if indice_sac<len(sac)-1:
                indice_sac+=1
            else:
                sac.append([])
                indice_sac+=1
        sac[indice_sac].append(masses[indice])
        masses.pop(indice)
    return len(sac)

def compareHeuGlou(taille, nbObjet, masse_max):
    """taille de l'echantillon et nb d'objets"""
    for i in range(taille):
        l=[randint(1, 10) for j in  range(nbObjet)]
        #plt.plot(i, nb2SacMin(l,10), 'bo')
        sacOp=rechercheOptimal(l,masse_max)
        
        #sacGlou=glouRetour(l,masse_max)
        sacFf=firstFit(l,masse_max)
        #plt.plot(i, sacGlou,'gs')
        plt.plot(i,len(sacOp), 'bo')
        plt.plot(i, sacFf[0],'r*')
        
        if len(sacOp)!=sacFf[0]:
            print(l,sacOp,sacFf[1])
    #graphique
    plt.xlabel("Numero d'essai pour "+ str(nbObjet) + " objets")
    plt.ylabel("Nombre de sacs") 
    plt.show()


