def nb2SacMin(l, taillesac):
    poidsTot=sum(l)
    if poidsTot%taillesac==0:
        return int(poidsTot/taillesac)
    else:
        return poidsTot//taillesac+1

def produit2Listes(l, m):
    prod=[]
    for i in l:
        for j in m:
            prod.append(i+j)
    return prod

def puissanceListe(l, n):
    """ une liste et un entier, renvoie toutes les combinaisons avec repetition de n élements de l"""
    if n == 1:
        return l
    else:
        listeAvant=puissanceListe(l,n-1)
        return(produit2Listes(l,tuple(listeAvant)))
    
def listeCombinaison(nbsac, nbObjet):
    l=[[i] for i in range(1,nbsac+1)]
    return puissanceListe(l,nbObjet)

    
def test1Combinaison(L, combi, nbsac, tailleSac):
    """test une combinaison donnée"""
    poidsSaci=[0]*nbsac
    for j in range(len(L)):
        poidsSaci[combi[j]-1]+=L[j] # ajouter les poids des objets dans chaque sac et stocke dans poidsSaci
    for sac in poidsSaci:
        if sac >tailleSac:          # test de taille
            return False 
    return True

def testAllCombinaison(L, nbSac, tailleSac):
    """ recherche un combinaison correcte pour un nombre de sac donné"""
    nbObjet= len(L)
    Combi= listeCombinaison(nbSac, nbObjet)          # creer la liste des possibles
    for l in Combi:
        if test1Combinaison(L, l, nbSac, tailleSac): # teste chaque possible
            return l, nbSac
    return None
              
def showAllCombinaison(L, nbSac, tailleSac):
    """recherche toutes les combinaisons pour un nombre de sac donné"""
    nbObjet= len(L)
    combinaison= listeCombinaison(nbSac, nbObjet)        # creer la liste des possibles
    listeBonneCombi=[]
    for combi in combinaison:
        if test1Combinaison(L, combi, nbSac, tailleSac): # teste chaque possible
            miseEnForme= affichageSac(L,combi,nbSac)     # regroupe par sac
            listeBonneCombi.append(miseEnForme)          #l'ajoute a la liste des bonnes combinaisons
    return listeBonneCombi
                       
def rechercheOptimal(L, tailleSac):
    """recherche un rangement optimal au sens du nombre de sac"""
    nbsacmin= nb2SacMin(L, tailleSac)
    nbObjet= len(L)
    
    for i in range(nbsacmin, nbObjet+1):
        result= testAllCombinaison(L, i, tailleSac)
        if result :
            return affichageSac(L,*result)             # regroupe par sac et affiche
    return 'Impossible'